package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMRFOCA;
import cn.ibizlab.eam.core.eam_core.filter.EMRFOCASearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMRFOCA] 服务对象接口
 */
public interface IEMRFOCAService extends IService<EMRFOCA>{

    boolean create(EMRFOCA et) ;
    void createBatch(List<EMRFOCA> list) ;
    boolean update(EMRFOCA et) ;
    void updateBatch(List<EMRFOCA> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMRFOCA get(String key) ;
    EMRFOCA getDraft(EMRFOCA et) ;
    boolean checkKey(EMRFOCA et) ;
    boolean save(EMRFOCA et) ;
    void saveBatch(List<EMRFOCA> list) ;
    Page<EMRFOCA> searchDefault(EMRFOCASearchContext context) ;
    List<EMRFOCA> selectByRfodeid(String emrfodeid) ;
    void removeByRfodeid(String emrfodeid) ;
    List<EMRFOCA> selectByRfomoid(String emrfomoid) ;
    void removeByRfomoid(String emrfomoid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMRFOCA> getEmrfocaByIds(List<String> ids) ;
    List<EMRFOCA> getEmrfocaByEntities(List<EMRFOCA> entities) ;
}


